package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;
import java.util.Optional;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.EmpresaIziPayDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EmpresaIziPayConfig;

@Repository("empresaIziPayDAO")
public class EmpresaIziPayHibernateDAO extends GenericHibernateDAO<EmpresaIziPayConfig, Integer>
		implements EmpresaIziPayDAO {

	@Autowired
	public EmpresaIziPayHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<EmpresaIziPayConfig> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("activo", Boolean.TRUE));

		return c.list();
	}

	@Override
	public Optional<EmpresaIziPayConfig> buscarPorEmpresa(Empresa empresa) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("activo", Boolean.TRUE));
		c.add(Restrictions.eq("empresa.empresaId", empresa.getEmpresaId()));

		return Optional.ofNullable((EmpresaIziPayConfig) c.uniqueResult());
	}
}
